unit UArrondiMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan;

type
  TForm8 = class(TForm)
    edt_Real: TEdit;
    cbb_RndMode: TComboBox;
    cbb_PrcMode: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    btn_Round: TButton;
    lbl_Result: TLabel;
    Label4: TLabel;
    edt_Digit: TEdit;
    Label5: TLabel;
    procedure btn_RoundClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbb_RndModeChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form8: TForm8;

implementation

{$R *.dfm}
uses Math;
var
    OldRndMode: TFPURoundingMode;
    OldPrcMode: TFPUPrecisionMode;


procedure TForm8.btn_RoundClick(Sender: TObject);
var nbr:Real;
    RndMode: TFPURoundingMode;
    PrcMode: TFPUPrecisionMode;
begin
  nbr := StrToFloat(edt_Real.Text);
  PrcMode := SetPrecisionMode(TFPUPrecisionMode(cbb_PrcMode.ItemIndex));
  RndMode := SetRoundMode(TFPURoundingMode(cbb_RndMode.ItemIndex));
  lbl_Result.Caption := floattostr(RoundTo(nbr, -StrToIntDef(edt_Digit.Text, 2)));
end;

procedure TForm8.FormCreate(Sender: TObject);
begin
  OldRndMode := GetRoundMode;
  OldPrcMode := GetPrecisionMode;

  cbb_RndMode.ItemIndex := Ord(OldRndMode);
  cbb_PrcMode.ItemIndex := Ord(OldPrcMode);

  SetWindowLong(edt_Digit.Handle,GWL_STYLE,GetWindowLong(edt_Digit.Handle,GWL_STYLE) or ES_NUMBER);
end;

procedure TForm8.FormDestroy(Sender: TObject);
begin
  SetRoundMode(OldRndMode);
  SetPrecisionMode(OldPrcMode);
end;

procedure TForm8.cbb_RndModeChange(Sender: TObject);
begin
  btn_Round.Click;
end;

end.
